> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/infra-controller/_mcp/server.

# Retrieve all Expected Racks

GET https://nico-rest-api.nico.svc.cluster.local/v2/org/{org}/nico/expected-rack

Retrieve all Expected Racks.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER` role.

Alternatively, Tenant Admins with `TargetedInstanceCreation` capability can also retrieve Expected Racks if they have an account with the Site's Infrastructure Provider (siteId query parameter is required for Tenants).

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/expected-rack/get-all-expected-rack

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NVIDIA Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/nico/expected-rack:
    get:
      operationId: get-all-expected-rack
      summary: Retrieve all Expected Racks
      description: >-
        Retrieve all Expected Racks.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER` role.


        Alternatively, Tenant Admins with `TargetedInstanceCreation` capability
        can also retrieve Expected Racks if they have an account with the Site's
        Infrastructure Provider (siteId query parameter is required for
        Tenants).
      tags:
        - subpackage_expectedRack
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: siteId
          in: query
          description: ID of the Site to filter Expected Racks by
          required: false
          schema:
            type: string
            format: uuid
        - name: includeRelation
          in: query
          description: Related entity to expand
          required: false
          schema:
            $ref: >-
              #/components/schemas/V2OrgOrgNicoExpectedRackGetParametersIncludeRelation
        - name: pageNumber
          in: query
          description: Page number for pagination query
          required: false
          schema:
            type: integer
            default: 1
        - name: pageSize
          in: query
          description: Page size for pagination query
          required: false
          schema:
            type: integer
        - name: orderBy
          in: query
          description: Ordering for pagination query
          required: false
          schema:
            $ref: '#/components/schemas/V2OrgOrgNicoExpectedRackGetParametersOrderBy'
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ExpectedRack'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
servers:
  - url: https://nico-rest-api.nico.svc.cluster.local
components:
  schemas:
    V2OrgOrgNicoExpectedRackGetParametersIncludeRelation:
      type: string
      enum:
        - Site
      title: V2OrgOrgNicoExpectedRackGetParametersIncludeRelation
    V2OrgOrgNicoExpectedRackGetParametersOrderBy:
      type: string
      enum:
        - RACK_ID_ASC
        - RACK_ID_DESC
        - RACK_PROFILE_ID_ASC
        - RACK_PROFILE_ID_DESC
        - CREATED_ASC
        - CREATED_DESC
        - UPDATED_ASC
        - UPDATED_DESC
      title: V2OrgOrgNicoExpectedRackGetParametersOrderBy
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    ExpectedRack:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier (UUID) for the Expected Rack
        rackId:
          type: string
          description: >-
            Operator-supplied identifier for the rack (string, not UUID). Unique
            within a Site.
        siteId:
          type: string
          format: uuid
          description: ID of the Site the Expected Rack belongs to
        rackProfileId:
          type: string
          description: Identifier of the Rack Profile this rack conforms to
        name:
          type: string
          description: Human-readable name of the Expected Rack
        description:
          type: string
          description: Human-readable description of the Expected Rack
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Racks. Well-known keys (`chassis.*`, `location.*`) are used
            to convey chassis identity and physical location.
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Rack was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Rack was last updated
      description: >-
        An Expected Rack represents a rack that is expected to be discovered at
        a Site. The `rackId` is an operator-supplied string identifier (not a
        UUID) that uniquely identifies the rack within the Site. Each Expected
        Rack references a Rack Profile that describes the rack's expected layout
        and capabilities.


        Chassis identity and physical location information are conveyed via
        well-known label keys in `labels`:

        - `chassis.manufacturer`, `chassis.serial-number`, `chassis.model`

        - `location.region`, `location.datacenter`, `location.room`,
        `location.position`
      title: ExpectedRack
    NiCoApiErrorSource:
      type: string
      enum:
        - nico
      description: Source of the error.
      title: NiCoApiErrorSource
    NiCoApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: NiCoApiErrorData
    NICoAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/NiCoApiErrorSource'
          description: Source of the error.
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/NiCoApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NVIDIA Infra Controller REST API
      title: NICoAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/expected-rack")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```